/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.jboss.qa.brms.cameljboss.tools;

import javax.naming.Context;

import org.apache.camel.CamelContext;
import org.apache.camel.ProducerTemplate;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.impl.DefaultCamelContext;
import org.apache.camel.util.jndi.JndiContext;
import org.drools.grid.GridNode;
import org.drools.grid.impl.GridImpl;
import org.drools.runtime.StatefulKnowledgeSession;

/**
 * General Camel command executor configuring
 * @author rsynek
 */
public abstract class AbstractCamelCommandExecutor implements ICamelCommandExecutor {

    public static final String LOOKUP_ENDPOINT = "direct:test-lookup";

    protected String endpoint;

    protected ProducerTemplate template;

    protected CamelContext camelContext;

    /**
     * grid node creation and binding
     */
    protected Context configureGrid(
            StatefulKnowledgeSession session,
            final String nodeName,
            final String sessionName) throws Exception {
        GridImpl grid = new GridImpl(new java.util.HashMap<String, Object>());
        GridNode node = grid.createGridNode(nodeName);
	Context context = new JndiContext();
	context.bind(nodeName, node);
        node.set(sessionName, session);
        return context;
    }

    /** 
     * creates Camel context and starts it, creates producer template
     * for command execution
     */
    @Override
    public void configure(
            StatefulKnowledgeSession session,
            final String nodeName,
            final String sessionName,
            final String fromExpression) throws Exception {

        this.endpoint = fromExpression;
        init();
        Context context = configureGrid(session, nodeName, sessionName);
        camelContext = new DefaultCamelContext(context); 
        
     //   camelContext.setPackageScanClassResolver(new org.apachextras.camel.jboss.JBossPackageScanClassResolver());
        camelContext.setPackageScanClassResolver(new JBossPackageScanClassResolver());
        camelContext.addRoutes(createRouteBuilder(fromExpression, nodeName,
                sessionName));

        template = camelContext.createProducerTemplate();

        camelContext.start();
    }

    protected abstract void init();

    /**
     * routes are specific for each command executor type
     */
    protected abstract RouteBuilder createRouteBuilder(
            final String fromExpression,
            final String nodeName,
            final String sessionName);
}
