/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.jboss.qa.brms.cameljboss.tools;

import java.util.Collection;
import java.util.List;
import java.util.Map;

import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.rule.FactHandle;
import org.drools.runtime.rule.QueryResults;
import org.jboss.qa.brms.cameljboss.model.Person;

/**
 * Command executor interface; simply all supported drools commands + executor
 * configuration.
 * @author rsynek
 */
public interface ICamelCommandExecutor {

    public void configure(
            StatefulKnowledgeSession session,
            final String nodeName,
            final String sessionName,
            final String fromExpression) throws Exception;

    public FactHandle batchInsertFire(Person p);

    public Person getObject(FactHandle fh);

    public Collection<?> getObjects();

    public void modify(Person p, FactHandle fh);

    public void retract(FactHandle fh);

    public Person getGlobal(String globalId);

    public void setGlobal(Person p, String globalId);

    public void startProcess(String processId);

    public void signalEvent(String type, String event);

    public void insertElements(List<Person> objects);

    public QueryResults query(String queryName, Object[] args);

    public void completeWorkItem(long id, Map<String, Object> results);

    public void abortWorkItem(long id);

    public void insertWithLookup(Person p);
}
